<ul class="breadcrumb">
	<li><a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a></li>
	<li><?= $this->translate('budget_module_title') ?></li>
	<li class="active"><?= $this->translate('budget_import_module_title') ?></li>
</ul>

<h1 class="page-title">
	<?= $this->icon('import') ?> <?= $this->translate('budget_import_module_title') ?>
</h1>

<div class="row row-padding" ng-controller="importBudgetController as self">
	<div class="col-xs-12">
		<div class="panel">
			<div class="panel-heading">
				<?= $this->translate('budget_import_module_title') ?>
			</div>
			<div class="panel-body">
				<div class="row">
					<div class="col-xs-12">
						<form action="" method="post" enctype="multipart/form-data">
							<div class="row">
								<div class="form-group col-xs-2">
									<label><?= $this->translate('import_budget_object') ?></label>
									<select ng-model="self.entity" class="form-control">
										<option value="expense"><?= ucfirst($this->translate('expense_entity')) ?></option>
										<option value="income"><?= ucfirst($this->translate('income_entity')) ?></option>
									</select>
								</div>
								<div class="form-group col-xs-2">
									<label><?= $this->translate('import_budget_type') ?></label>
									<select ng-model="self.type" class="form-control">
										<?php
										foreach ($this->allowedExpenseTypes() as $type) {
											echo '<option ng-if="self.entity == \'expense\'" value="' . $type . '">' . $this->translate('expense_type_' . $type) . '</option>';
										}
										foreach ($this->allowedIncomeTypes() as $type) {
											echo '<option ng-if="self.entity == \'income\'" value="' . $type . '">' . $this->translate('income_type_' . $type) . '</option>';
										}
										?>
									</select>
								</div>
							</div>
							<div class="row">
								<div class="form-group col-xs-2">
									<label><?= $this->translate('import_budget_mode') ?></label>
									<select ng-model="self.mode" class="form-control">
										<option value="add"><?= $this->translate('import_budget_mode_add') ?></option>
										<option value="eraseAll"><?= $this->translate('import_budget_mode_eraseAll') ?></option>
										<option value="eraseProjects"><?= $this->translate('import_budget_mode_eraseProjects') ?></option>
									</select>
								</div>
								<div class="form-group col-xs-2" ng-show="self.mode == 'eraseAll' || self.mode == 'eraseProjects'">
                                    <label><?= $this->translate('import_budget_erase_year') ?>  <i class="fa fa-exclamation-triangle" tooltip="<?= $this->translate('import_budget_erase_year_info')?>" data-html="true"  hide-if-empty></i>
                                    </label>
									<select ng-model="self.year" class="form-control">
										<option value="all"><?= $this->translate('import_budget_erase_year_all') ?></option>
										<?php
										foreach ($this->years as $type => $years) {
											foreach ($years as $year) {
												echo '<option value="' . $year . '" ng-if="self.entity == \'' . $type . '\'"">' . $year . '</option>';
											}
										}
										?>
									</select>
								</div>
							</div>
							<div class="row">
								<div class="form-group col-xs-2">
									<label><?= $this->translate('import_budget_status') ?></label>
									<budget-status-select ng-model="self.status" only-value="true"></budget-status-select>
								</div>
								<div class="form-group col-xs-3">
									<?= $this->translate('import_transaction_in_poste_account_parent') ?>
									<br/>
									<input type="checkbox" ng-model="self.inPosteAccountParent"/>
								</div>
							</div>
							<div class="row">
								<div class="form-group col-xs-12">
									<label><?= $this->translate('import_file') ?> <?= $this->icon('loading', '', ['ng-show' => 'self.loading.upload || self.loading.parse']) ?></label>
									<input type="file" nv-file-select uploader="self.uploader"/>
								</div>
							</div>
							<div class="row">
								<div class="form-group col-xs-2">
									<label><?= $this->translate('import_delimiter') ?></label>
									<input type="text" class="form-control" ng-model="self.options.delimiter"/>
								</div>
								<div class="form-group col-xs-3">
									<?= $this->translate('import_first_line_contains_header') ?>
									<br/>
									<input type="checkbox" ng-model="self.options.firstLine"/>
								</div>
							</div>
							<div class="row">
								<div class="form-group col-xs-6">
									<button type="button" class="btn btn-success btn-xs" ng-click="self.parse()" ng-disabled="!self.options.file">
										<?php echo ucfirst($this->translate('send')) ?>
									</button>
									<button type="button" class="btn btn-success btn-xs" ng-click="self.validate()" ng-disabled="!self.options.isParsed">
										<?= $this->icon('loading', '', ['ng-show' => 'self.loading.validate']) ?>
										<?php echo ucfirst($this->translate('validate')) ?>
									</button>
									<button type="button" class="btn btn-primary btn-xs" ng-click="self.save()" ng-disabled="!self.options.isValidated">
										<?= $this->icon('loading', '', ['ng-show' => 'self.loading.save']) ?>
										<?php echo $this->translate('Import') ?>
									</button>
                                    <i class="fa fa-info-circle" tooltip="<?= $this->translate('import_message_info')?>" data-html="true"  hide-if-empty></i>
                                </div>
							</div>
						</form>
					</div>
				</div>
				<div ng-if="self.properties.length > 0">
					<div class="col-sm-4">
						<table-builder-queries headers="self.properties" name="budget-import"></table-builder-queries>
					</div>
					<div class="col-sm-4 col-sm-offset-4">
						<div class="form-group text-right" ng-show="self.options.isParsed">
							<button type="button" class="btn btn-xs" ng-click="self.addLine()">
								<?php echo $this->translate('import_add_line') ?>
							</button>
							<button type="button" class="btn btn-xs" ng-click="self.addColumn()">
								<?php echo $this->translate('import_add_column') ?>
							</button>
						</div>
					</div>
					<div class="row">
						<div class="col-xs-12">
							<div class="table-scroller">
								<table class="table table-bordered table-import">
									<thead>
										<tr>
											<th ng-repeat="property in self.properties track by $index">
												<select class="form-control" style="width:auto" ng-model="self.properties[$index]">
													<option ng-value="null"></option>
													<?php
													foreach ($this->inputs as $entityName => $inputs) {
														foreach ($inputs as $input) {
															if ($input->getName() !== 'project') {
																echo '<option ng-if="self.entity == \'' . $entityName . '\'" value="' . $input->getName() . '" class="' . ($input->isRequired() ? 'required' : '') . '" ng-disabled="self.disableOption($index, \'' . $input->getName() . '\')">';
																echo $this->translate($entityName . '_field_' . $input->getName()) . ($input->isRequired() ? '*' : '');
																echo '</option>';
															}
														}
													}
													echo '<optgroup label="' . ucfirst($this->translate('project_entity')) . '*" class="required">';
													echo '<option value="project_code" ng-disabled="self.disableOption($index, \'project_code\')">' . $this->translate('project_field_code') . '</option>';
													echo '<option value="project_name" ng-disabled="self.disableOption($index, \'project_name\')">' . $this->translate('project_field_name') . '</option>';
													foreach ($this->customFields as $field) {
														echo '<option value="project_field_' . $field->getId() . '" ng-disabled="self.disableOption($index, \'project_field_' . $field->getId() . '\')">' . $field->getName() . '</option>';
													}
													echo '</optgroup>';
													?>
												</select>
											</th>
											<th class="fit-content"></th>
										</tr>
									</thead>
									<tbody>
										<tr ng-repeat="line in self.lines track by $index"
										    ng-class="{
                                                success: self.options.isValidated && !self.errors[$index],
                                                danger: self.options.isValidated && self.errors[$index]
                                            }">
											<td ng-repeat="column in line track by $index">
												<input type="text" class="form-control" ng-model="self.lines[$parent.$index][$index]"/>
												<field-errors field="{{self.properties[$index]}}" errors="self.errors[$parent.$index]"></field-errors>
											</td>
											<td>
												<button class="btn btn-default btn-xs" type="button" ng-click="self.deleteLine($index)">
													<?= $this->icon('delete', 'fa-fw') ?>
												</button>
											</td>
										</tr>
									</tbody>
								</table>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>

<?php
$this->angular('js/src/budget/directive/budgetStatusSelect.js');
$this->angular('js/src/budget/service/budgetStatus.js');

$this->angular('js/src/application/query/service/query.js');

$this->angular('js/src/budget/controller/import/index.js');
$this->angular('js/src/import/controller/import/index.js');
